Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class IndexSearcher

    java.lang.Object
      org.apache.lucene.search.Searcher
          org.apache.lucene.search.IndexSearcher

All Implemented Interfaces:
  Remote, Searchable

public class IndexSearcher
extends Searcher

Implements search over a single IndexReader.

Applications usually need only call the inherited `Searcher.search(Query)` or `Searcher.search(Query,Filter)` methods.

Constructor Summary
`IndexSearcher(Directory directory)` Creates a searcher searching the index in the provided directory.
`IndexSearcher(IndexReader r)` Creates a searcher searching the provided index.
`IndexSearcher(String path)` Creates a searcher searching the index in the named directory.

Method Summary
`void` | `close()` Note that the underlying IndexReader is not closed, if IndexSearcher was constructed with IndexSearcher(IndexReader r).
`Document` | `doc(int i)` Expert: Returns the stored fields of document `i`.
`int` | `docFreq(Term term)` Expert: Returns the number of documents containing `term`.
`Explanation` | `explain(Query query, int doc)` Returns an Explanation that describes how `doc` scored against `query`.
`int` | `maxDoc()` Expert: Returns one greater than the largest possible document number.
`Query` | `rewrite(Query original)` Expert: called to re-write queries into primitive queries.
`void` | `search(Query query, Filter filter, HitCollector results)` Lower-level search API.
`TopDocs` | `search(Query query, Filter filter, int nDocs)` Expert: Low-level search implementation.
`TopFieldDocs` | `search(Query query, Filter filter, int nDocs, Sort sort)` Expert: Low-level search implementation with arbitrary sorting.

Methods inherited from class org.apache.lucene.search.Searcher
`getSimilarity, search, search, search, search, search, setSimilarity`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### IndexSearcher

    public IndexSearcher(String path)
                  throws IOException

  Creates a searcher searching the index in the named directory.

### IndexSearcher

    public IndexSearcher(Directory directory)
                  throws IOException

  Creates a searcher searching the index in the provided directory.

### IndexSearcher

    public IndexSearcher(IndexReader r)

  Creates a searcher searching the provided index.

Method Detail

### close

    public void close()
               throws IOException

  Note that the underlying IndexReader is not closed, if IndexSearcher was constructed with IndexSearcher(IndexReader r). If the IndexReader was supplied implicitly by specifying a directory, then the IndexReader gets closed.

  Throws:
    `IOException`

### docFreq

    public int docFreq(Term term)
                throws IOException

  Description copied from interface: `Searchable`
  Expert: Returns the number of documents containing `term`. Called by search code to compute term weights.

  Throws:
    `IOException`
  See Also:
    `IndexReader.docFreq(Term).`

### doc

    public Document doc(int i)
                 throws IOException

  Description copied from interface: `Searchable`
  Expert: Returns the stored fields of document `i`. Called by `HitCollector` implementations.

  Throws:
    `IOException`
  See Also:
    `IndexReader.document(int).`

### maxDoc

    public int maxDoc()
               throws IOException

  Description copied from interface: `Searchable`
  Expert: Returns one greater than the largest possible document number. Called by search code to compute term weights.

  Throws:
    `IOException`
  See Also:
    `IndexReader.maxDoc().`

### search

    public TopDocs search(Query query,
                          Filter filter,
                          int nDocs)
                   throws IOException

  Description copied from interface: `Searchable`
  Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

  Called by `Hits`.

  Applications should usually call `Searcher.search(Query)` or `Searcher.search(Query,Filter)` instead.

  Throws:
    `IOException`

### search

    public TopFieldDocs search(Query query,
                               Filter filter,
                               int nDocs,
                               Sort sort)
                        throws IOException

  Description copied from interface: `Searchable`
  Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

  Applications should usually call `Searcher.search(Query,Filter,Sort)` instead.

  Throws:
    `IOException`

### search

    public void search(Query query,
                       Filter filter,
                       HitCollector results)
                throws IOException

  Description copied from interface: `Searchable`
  Lower-level search API.

  `HitCollector.collect(int,float)` is called for every non-zero scoring document.

  Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

  Parameters:
    `query` - to match documents
    `filter` - if non-null, a bitset used to eliminate some documents
    `results` - to receive hits
  Throws:
    `IOException`

### rewrite

    public Query rewrite(Query original)
                  throws IOException

  Description copied from interface: `Searchable`
  Expert: called to re-write queries into primitive queries.

  Throws:
    `IOException`

### explain

    public Explanation explain(Query query,
                               int doc)
                        throws IOException

  Description copied from interface: `Searchable`
  Returns an Explanation that describes how `doc` scored against `query`.

  This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2005 Apache Software Foundation. All Rights Reserved.